# NUCLEO-H563ZI Nucleo-144 board

## Overview

The STM32H5 Nucleo-144 board based on the MB1404 reference board (order code NUCLEO-H563ZI) provides an affordable and flexible way for users to try out new concepts and build prototypes, by choosing from the various combinations of performance and power consumption features provided by the STM32H5 series microcontroller.

The ST Zio connector, which extends the ARDUINO® Uno V3 connectivity, and the ST morpho headers provide an easy extension of the functionality of the STM32 Nucleo open development platform with a wide choice of specialized shields.

The STM32H5 Nucleo-144 board does not require any separate probe as it integrates the STLINK-V3EC debugger/programmer.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um3115-stm32h5-nucleo144-board-mb1404-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32H563ZI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32h563zi.html)
- [NUCLEO-H563ZI board](https://www.st.com/en/evaluation-tools/nucleo-h563zi.html)
- [User manual](https://www.st.com/resource/en/user_manual/um3115-stm32h5-nucleo144-board-mb1404-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/nucleo-h563zi.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1404-h563zi-c01-schematic.pdf)
